#include <stdio.h>

#define TAM 10

void imprimePassos (int *v, int tam, int passo)
{
  int i;

  printf("Passo %d: -->  ", passo);

  for (i=0; i < tam; ++i)
    printf ("%d ", v[i]);

  printf ("\n");
}

/* Uma funcao  que encontra o menor valor em um  array entre os indices
 * "a" e "b" (inclusive)
 */
int menor_indice(int *v, int a, int b)
{
  int i, menor;

  menor = a;
  for (i = a+1; i <= b; ++i)
    if ( v[i] < v[menor] ) menor = i;
  
  return menor;
}


/* Uma funcao que troca os valores entre dois elementos de um array */
void troca_v( int *vet, int i, int j)
{
  int aux;
   
  aux = vet[i];
  vet[i] = vet[j];
  vet[j] = aux;
}

/* Uma funcao que ordena um array de inteiros usando o algoritmo de
 * Bubble sort.
 * Entrada:  array a ser ordenado -- lista[]
 *           tamanho do array -- tam
 */
void ordena(int *lista, int tam)
{
  int i,j,
      menor;    /* indice do menor valor no array entre i e tam-1 */
  
  for (i=0; i < tam; ++i)
  {
    imprimePassos( lista, tam, i );
    menor = menor_indice( lista, i, tam-1 );
    troca_v( lista, i, menor );
  }
}

int main()
{
  int i, data1[TAM];
  
  printf("Entre %d valores inteiros: ", TAM);
  for (i=0; i < TAM; ++i)
    scanf("%d", data1+i);

  ordena(data1, TAM);

  printf("Dados ordenados: \n");

  for (i=0; i < TAM; ++i)
    printf ("%4d", data1[i]);

  printf("\n");

  return(0);
}
